﻿namespace Interval.CZ.WebCMS
{
  using System;
  using System.Data;
  using System.Data.SqlClient;
  using System.Web.UI;
  using System.Web.UI.WebControls;
  using System.Web.UI.HtmlControls;

  public abstract class ServerMap : System.Web.UI.Page
  {
    protected System.Web.UI.WebControls.Repeater Repeater1;
    protected DataTable treeDataTable = new DataTable();

    private void MenuItemCreated(object sender, System.Web.UI.WebControls.RepeaterItemEventArgs e)
    {
      if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
      {
        DataRow myRow = (DataRow) e.Item.DataItem;
        DataRow[] subItem = treeDataTable.Select("ParentItemID = " + myRow[0].ToString());
        if (subItem.Length > 0)
        {
          Repeater parentRepeater = (Repeater) sender;
          Repeater subitemRepeater = new Repeater();
          subitemRepeater.EnableViewState = false;
          subitemRepeater.ItemTemplate = parentRepeater.ItemTemplate;
          subitemRepeater.HeaderTemplate = parentRepeater.HeaderTemplate;
          subitemRepeater.FooterTemplate = parentRepeater.FooterTemplate;
          subitemRepeater.ItemCreated += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.MenuItemCreated);
          subitemRepeater.DataSource = subItem;
          subitemRepeater.DataBind();
          e.Item.Controls.Add(subitemRepeater);
        }
      }
    }

    private void Page_Load(object sender, System.EventArgs e)
    {
      SqlCommand myCommand = new SqlCommand("dbo.GetServerMap",new SqlConnection(System.Configuration.ConfigurationSettings.AppSettings["ConnectionString"]));
      myCommand.CommandType = CommandType.StoredProcedure;
      try
      {
        SqlDataAdapter mySqlDataAdapter = new SqlDataAdapter(myCommand);
        mySqlDataAdapter.Fill(treeDataTable);
        mySqlDataAdapter.Dispose();
        treeDataTable.Columns["ItemID"].Unique = true;
        treeDataTable.PrimaryKey = new DataColumn[] {treeDataTable.Columns["ItemID"]};
      }
      catch
      {

      }
      if (treeDataTable.Rows.Count > 0)
      {
        Repeater1.ItemTemplate = Page.LoadTemplate("~/Controls/ServerMapItemTemplate.ascx");
        Repeater1.HeaderTemplate =  Page.LoadTemplate("~/Controls/ServerMapHeaderTemplate.ascx");
        Repeater1.FooterTemplate = Page.LoadTemplate("~/Controls/ServerMapFooterTemplate.ascx");
        Repeater1.DataSource = treeDataTable.Select("ParentItemID = 0");
        Repeater1.DataBind();
      }
      treeDataTable.Dispose();
    }

    #region Web Form Designer generated code
    override protected void OnInit(EventArgs e)
    {
      //
      // CODEGEN: This call is required by the ASP.NET Web Form Designer.
      //
      InitializeComponent();
      base.OnInit(e);
    }

    ///    Required method for Designer support - do not modify
    ///    the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      this.Load += new System.EventHandler(this.Page_Load);
      Repeater1.ItemCreated += new System.Web.UI.WebControls.RepeaterItemEventHandler(this.MenuItemCreated);
    }
    #endregion
  }
}
